//    Single__library_github.com

int JK=3;       // количество измерений в одной серии, JK < 11         
                                               // the number of measurements in the first series, JK < 11
int JJK=1;      // количество серий измерений                          
                                               //  number of measurement series
double AA[10];  // для текущего измеренного значения, размер меньше 11 
                                               // for the current measured value, the size is less than 11
double AA1;     // для накопления суммы значений          // to accumulate the sum of values
double AA2;     // для среднего значения по одной серии   // for the average value of one series
double D1[10];  // среднее отклонение для каждого измерения внутри одной серии
                                               // average deviation for each measurement within one series
double DA1[10]; // среднее квадратичноое отклонение для каждого измерения внутри одной серии 
                                               // standard deviation for each measurement within one series
double D;       // для среднего значения квадратичного отклонения по одной серии 
                                              // for the mean square deviation of one series
double Dispers; // дисперсия (относительная) по одной серии = > Dispers= D/AA2
                                             // variance (relative) for one series  = > Dispers= D/AA2
byte Baddress;               // для считывания  адреса                     // to read the address
float BFtiming;              //  для считывания TimingBudget               // to read TimingBudget
float BPeriodPre;            //  для считывания периода                    // to read the period
float BRateLimit;            //  скорость обратного сигнала в MCPS         // return speed in MCPS
byte BVcselPulsePeriodPre;   //  период Pre тактового генератора лазера    // period Pre of the laser clock
byte BVcselPulsePeriodFinal; //  период Final тактового генератора лазера  // period Final of the laser clock
byte BbID;                   //  ID датчика                                // sensor ID 
byte Bb_Sys_Sequence_Config; //  последовательность конфигурации системы   // system configuration sequence
byte B_l_status;             //  чтение остояния последней передачи записи I2C



#include <Wire.h>         //  библиотека  I2C                             // I2C library
#include <VL53L0X.h>      //  библиотека сенсора от Pololu                // sensor library from Pololu

VL53L0X sensor;




//#define LONG_RANGE  //  Лучше всего работает в темноте  // It works best in dark  conditions.

//
// Uncomment ONE of these two lines to get
// - higher speed at the cost of lower accuracy OR
// - higher accuracy at the cost of lower speed

//#define HIGH_SPEED // более высокая скорость за счет меньшей точности // higher accuracy at the cost of lower speed
#define HIGH_ACCURACY //  higher accuracy   //  более высокая точность//                       < < = = = 



void setup()

{
 
  Serial.begin(9600);
  Wire.begin();

  sensor.setTimeout(500);
  if (!sensor.init())
  {
    Serial.println("Failed to detect and initialize sensor!");
    // "Не удалось обнаружить и инициализировать датчик!"
    while (1) {}
  }

   

#if defined LONG_RANGE
  // lower the return signal rate limit (default is 0.25 MCPS)
  // понизьте предел скорости возвратного сигнала (по умолчанию 0.25 МКПС)
  sensor.setSignalRateLimit(0.1);
  // increase laser pulse periods (defaults are 14 and 10 PCLKs)
  // увеличение периодов лазерных импульсов (по умолчанию 14 и 10 PCLKs)
  sensor.setVcselPulsePeriod(VL53L0X::VcselPeriodPreRange, 18);
  sensor.setVcselPulsePeriod(VL53L0X::VcselPeriodFinalRange, 14);
  
#endif

#if defined HIGH_SPEED
  // reduce timing budget to 20 ms (default is about 33 ms)
  sensor.setMeasurementTimingBudget(20000);
#elif defined HIGH_ACCURACY
  // increase timing budget to 200 ms  =>   400
  sensor.setMeasurementTimingBudget(400000);
#endif

  F_address();
  F_timing();
  F_SignalRateLimit();
  F_VcselPulsePeriod();
  F_status();
  F_ID_register();
  F_Sys_Sequence_Config();
  F_spad_reg();

  F_Measurement();
    
}       //    конец   блока   void setup() //  end of block  void setup()

//        &       &       &       &        &       &       &       &
void loop(){ 
  // Получаем команды на повторение  измерений // Get commands to repeat measurements
  String str = Serial.readString();
  if (str == "repeat") {
        Serial.println();
        Serial.println ("   п о в т о р е н и е    и з м е р е н и й");
        Serial.println();    
          F_Measurement();
                      };

  // Получаем команды на повторение  команд из библиотеки // Get commands to repeat commands from the library
  if (str == "library") {
        Serial.println();
        Serial.println ("   п о в т о р е н и е    к о м а н д    б и б л и о т е к и");
        Serial.println();    
          F_address();
          F_timing();
          F_SignalRateLimit();
          F_VcselPulsePeriod();
          F_status();
          F_ID_register();
          F_Sys_Sequence_Config();
                      };  
  
   // Получаем команды на повторение изучаемых команд   и  измерений // Get the commands to repeat the studied commands and measurements
  if (str == "repeatTotal") {
        Serial.println();
        Serial.println ("   п о в т о р е н и е    к о м а н д    б и б л и о т е к и    и    и з м е р е н и й");
        Serial.println(); 
          F_address();
          F_timing();
          F_SignalRateLimit();
          F_VcselPulsePeriod();
          F_status();
          F_ID_register();
          F_Sys_Sequence_Config();
          F_Measurement();

                      };  
                                        
      }
      ;
//        &       &       &       &        &       &       &       &


void F_Measurement() {
//        *       *       *       *        *       *       *       *

//          заданные  количества  измерений //  number of measurements
    Serial.println();
    Serial.print ("           И З М Е Р Е Н И Е        Р А С С Т О Я Н И Я    (MEASURING DISTANCE)"); 
    Serial.println();
    Serial.println();
    Serial.print ("количество измерений в одной серии (number of measurements in one series) = > ");
    Serial.print(JK);    
    Serial.print ("   количество  серий  измерений (number of measurement series)   = > ");
    Serial.println(JJK); 
    

  for (int IJ=1; IJ<=JJK; IJ++) {                     //    цикл  по  кол-ву  серий измерений

  Serial.println();
  Serial.print ("номер серии (the number of series of measurements)  = > ");
  Serial.print (IJ);
  
  Serial.print ("   проводим (perform) = > ");
  Serial.print (JK);
  Serial.println ("  измерений расстояния в мм (distance measurements in mm)");
  Serial.println();
  
    
    for (int J=1; J<=JK; J++) {                     //    цикл  по  измерениям  в одной серии // cycle for measurements in one series
       AA[J]=sensor.readRangeSingleMillimeters();   //    сохранение  результата в массиве // save the result in an array
       if (sensor.timeoutOccurred()) { Serial.print(" TIMEOUT"); }  
                            }
       {AA1=0;}                    
       for (int J=1; J<=JK; J++) {   // цикл для вычисления среднего значения в одной серии 
                                     // cycle to calculate the average value in one series   
        AA1=AA1+AA[J];               // накопление  суммы  для  одной  серии // accumulate the amount for one series
                                 }
                          
      AA2=AA1/double(JK);            // вычисление  среднего значения для одной серии // calculate the average value for one series
      
      for (int J=1; J<=JK; J++) {    // цикл для вычисления квадр. откл. из одной серии 
                                     // cycle for calculating quadratic deviations from one series    
        D1[J] = (AA[J]-AA2)/AA2;     // относительное  отклонение от среднего значения  // relative deviation from the mean
        DA1[J]=D1[J]*D1[J];          // квадрат относительного отклонения // squared relative deviation
                                }   

      D=0;
      for (int J=1; J<=JK; J++) {       // цикл для вычисления суммы квадратов квадратичных отклонений из одной серии 
                                        // cycle for calculating the sum of squared quadratic deviations from one series
        D=D+DA1[J]; 
                                }
        Dispers=D/double(JK);    //  вычисление относительной дисперсии для одной серии - это квадрат квадратичного отклонения
                                 // calculating the relative variance for one series is the square of the standard deviation
        D=sqrt(D/double(JK));    //  вычисление  среднего значения квадратичного отклоненния для одной серии  
                                 // calculate the mean square deviation for one series
       for (int J=1; J<=JK; J++) {   // печать результатов измерений из одной  серии // print measurement results from one series
                
        Serial.print("  расстояние(distance) = > ");
        Serial.print(AA[J]);  
        Serial.print ("  отн. откл. (relative deviation)= > ");           
        Serial.print(D1[J]*100.0,8); 
        Serial.print(" % ");
        Serial.print ("   относит. квадр. отклонение (relative standard deviation) = > ");           
        Serial.print(DA1[J]*100.0,8); 
        Serial.print(" % ");                
        Serial.println();
                         }  
        Serial.println();                         
        Serial.print ("среднее значение расстояния (average distance) = > ");
        Serial.print(AA2);
        Serial.println (" мм ");
        Serial.print ("среднее значение относит квадратичного отклонения (relative standard deviation) = > ");
        Serial.print(D*100.0,8);
        Serial.println(" % "); 
        Serial.print ("относительная дисперсия (relative dispersion) = > ");
        Serial.print (Dispers,12);
        Serial.println();
        Serial.println();                          
      //return;
    }       //    конец   цикла  по  кол-ву  серий измерений

//        *       *       *       *        *       *       *       *           
}
;

  void F_address(){
//              чтение  адреса  датчика  //reading sensor address
    Baddress = sensor.getAddress();   //  чтение  адреса  датчика
    Serial.println();
    Serial.print ("адрес датчика (sensor address)   HEX = > 0x");
    Serial.print(Baddress, HEX);
    Serial.print ("    ");
    Serial.print(" DEC = > " );
    Serial.print(Baddress, DEC);
    Serial.print ("   BIN  = > " );
    Serial.println(Baddress, BIN);
    if (Baddress == 41) {
      Serial.print("этот адрес является адресом по умолчанию    ADDRESS_DEFAULT  = > 0b0101001" );
                                   }
    Serial.println();
    Serial.print("   примечание (note):");
    Serial.println("   A->10  B->11  C->12  D->13  E->14  F->15");
    Serial.println();
  };

  void F_timing(){    

//      печать  тайминга  TimingBudget
  BFtiming=float(sensor.getMeasurementTimingBudget());
  Serial.print ("задан Timing     TimingBudget = > ");
  Serial.print (BFtiming);
  Serial.print("  мксек (microsecond)  ");
  Serial.println();

  };  

  void F_SignalRateLimit(){     
//              чтение  предела частоты сигнала  SignalRateLimit
        Serial.println();
        BRateLimit=sensor.getSignalRateLimit(); //  скорость обратного сигнала в MCPS
        Serial.print("скорость максимальная  SignalRateLimit = > ");
        Serial.print(BRateLimit);
        Serial.print("  миллионов в секунду (million per second)");
        Serial.println();
  };

void F_VcselPulsePeriod(){       
 //              чтение  VcselPulsePeriod VcselPeriodPreRange
        BVcselPulsePeriodPre=sensor.getVcselPulsePeriod(VL53L0X::VcselPeriodPreRange);
        Serial.println(); 
        Serial.print("период импульсов лазера  VcselPeriodPreRange    = > ");
        Serial.print(BVcselPulsePeriodPre);
        Serial.print("  периодов тактовой частоты лазера (laser clock periods)");
        Serial.println();
//              чтение  VcselPulsePeriod  VcselPeriodPreFinal
      BVcselPulsePeriodFinal=sensor.getVcselPulsePeriod(VL53L0X::VcselPeriodFinalRange); 
        Serial.print("период импульсов лазера  VcselPeriodFinaleRange = > ");
        Serial.print(BVcselPulsePeriodFinal);
        Serial.print("  периодов тактовой частоты лазера (laser clock periods)");
        Serial.println();
  };

void F_status(){
    B_l_status=sensor.last_status;
        Serial.println();
        Serial.print("Состояние последней передачи записи I2C (last_status)  ");
        Serial.print("   HEX = > ");
        Serial.print (B_l_status, HEX);
        Serial.print("    DEC = > ");
        Serial.print (B_l_status, DEC);
        Serial.print ("    BIN  = > " );
        Serial.println(B_l_status, BIN);
        if (B_l_status==0) {
        Serial.print("последняя запись в I2C прошла успешно (last entry in I2C was successful)");}
        else {
        Serial.print("последняя запись в I2C прошла с ошибкой (last entry in I2C failed)");}  
        Serial.println();    
     };

  void F_ID_register(){
//        проверить регистр ID модели (значение указано в справочнике данных) //  должно = 238
        Serial.println();
        Serial.print("регистр ID модели (IDENTIFICATION_MODEL_ID)  ");
        BbID=sensor.readReg (VL53L0X::IDENTIFICATION_MODEL_ID);
        Serial.print("    HEX = > ");
        Serial.print (BbID, HEX);
        Serial.print("    DEC = > ");
        Serial.print (BbID, DEC);
        Serial.println();
   };

  void F_Sys_Sequence_Config(){
//        проверить последовательность конфигурации системы  //  должно быть = FF = 255 ??
        Serial.println();
        Serial.print("последовательность конфигурации системы (SYSTEM_SEQUENCE_CONFIG)   ");
        Bb_Sys_Sequence_Config=sensor.readReg (VL53L0X::SYSTEM_SEQUENCE_CONFIG);
        Serial.print("    HEX = > ");
        Serial.print (Bb_Sys_Sequence_Config, HEX);
        Serial.print("    DEC = > ");
        Serial.println (Bb_Sys_Sequence_Config, DEC);
        Serial.println();
  };

  
  void F_spad_reg(){    
     // SPAD (однофотонные лавинные диоды) // SPAD (single-photon avalanche diodes)
     // команды из https://github.com/pololu/vl53l0x-arduino/blob/master/VL53L0X.cpp  
     // commands from https://github.com/pololu/vl53l0x-arduino/blob/master/VL53L0X.cpp 
  uint8_t ab1;
  uint8_t ab2;
  uint8_t ab3;
  uint8_t ab4;

  uint8_t spad_count;  
  uint8_t ref_spad_map[6];
  
  sensor.readMulti(VL53L0X::GLOBAL_CONFIG_SPAD_ENABLES_REF_0, ref_spad_map, 6);

//  ab1=sensor.readReg(0xFF);
  ab2=sensor.readReg(VL53L0X::DYNAMIC_SPAD_REF_EN_START_OFFSET);
  ab3=sensor.readReg(VL53L0X::DYNAMIC_SPAD_NUM_REQUESTED_REF_SPAD);
  ab4=sensor.readReg(VL53L0X::GLOBAL_CONFIG_REF_EN_START_SELECT);
  
//  Serial.print ("Reg(0xFF) = > ");
//  Serial.println(ab1, BIN);

  Serial.print ("DYNAMIC_SPAD_REF_EN_START_OFFSET      BIN = > ");
  Serial.print(ab2, BIN);
  Serial.print ("          HEX = > ");
  Serial.println(ab2, HEX);  
 
  Serial.print ("DYNAMIC_SPAD_NUM_REQUESTED_REF_SPAD   BIN  = > ");
  Serial.print(ab3, BIN);
  Serial.print ("         HEX  = > ");
  Serial.println(ab3, HEX);
 
  Serial.print ("GLOBAL_CONFIG_REF_EN_START_SELECT     BIN  = > ");
  Serial.print(ab4, BIN);
  Serial.print ("  HEX  = > ");
  Serial.println(ab4, HEX);
  Serial.println();

  for (int I=0; I<6; I++){

    Serial.print ("GLOBAL_CONFIG_SPAD_ENABLES_REF_0  (" );
    Serial.print (I);
    Serial.print(") BIN = > ");
    Serial.println(ref_spad_map[I], BIN);
    
                          }
     };
  









  
